#TEMPLATE(eip_queue, 'Adds EIP to a vanilla list box / relation tree'), family('ABC')
#EXTENSION(eip_queue, 'vanilla list box EIP')
#! by dan (no restrictions, use/modify at will)

#DISPLAY
#PROMPT ('List Control:', From(%Control)),%listControl
#PROMPT ('Queue: ', @s255), %treeQueue
#PROMPT ('EIP variable: ', @s255), %eipVariable
#DISPLAY
#PROMPT ('Relation Tree?', Check), %TreeMode
#DISPLAY
#SHEET
    #TAB('&ListBox Alerts')
        #DISPLAY('These initiate EIP on the list box!')
        #DISPLAY
        #BUTTON('listbox Alerts'),MULTI(%listBoxAlerts,%listBoxAlert),INLINE
            #PROMPT('listbox Alert:', @s255),%listBoxAlert
        #ENDBUTTON
    #ENDTAB
    #TAB('&Entry Alerts')
        #DISPLAY('These generate EVENT:ACCEPTED for the EIP control!')
        #DISPLAY
        #BUTTON('entry field Alerts'),MULTI(%entryAlerts,%entryAlert),INLINE
            #PROMPT('entry field Alert:', @s255),%entryAlert
        #ENDBUTTON
    #ENDTAB
#ENDSHEET

#AT(%LocalDataClassData)
?editEntry    equate(100)    
#ENDAT

#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),priority(9000)
    create(?editEntry, create:Entry)
    #FOR(%entryAlerts)
    ?editEntry{prop:alrt,255} = %entryAlert
    #ENDFOR

    #FOR(%listBoxAlerts)
    %listControl{prop:alrt,255} = %listBoxAlert
    #ENDFOR
#ENDAT

#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),Priority(4000)
    destroy(?editEntry)
#ENDAT

#AT(%controlEventHandling,%listControl,'NewSelection')
    !Shut off EIP if it's on
    #IF(%treeMode)
    currentColumn# = 1
    #ELSE
    currentColumn# = %listControl{prop:Column}
    #ENDIF    
    if %listControl{prop:Edit, currentColumn#} <> 0
        %listControl{prop:Edit, currentColumn#} = 0
    End
#ENDAT

#AT(%WindowManagerMethodCodeSection,'TakeFieldEvent','(),BYTE'),PRIORITY(3050)

of ?editEntry

    if event() = event:alertKey
        post(event:Accepted, ?editEntry)
    End

    if event() = event:Accepted
        #EMBED(%beforeEIPPut,'Before Put() to EIP Queue')
        put(%treeQueue)

        #IF(%treeMode)
        currentColumn# = 1
        #ELSE
        currentColumn# = %listControl{prop:Column}
        #ENDIF    

        %listControl{prop:Edit, currentColumn#} = 0
        select(%listControl, choice(%listControl))
        #EMBED(%afterEIPPut,'After Put() to EIP Queue')
    End

#ENDAT

#AT(%controlHandling, %listControl, 'AllEvents'),PRIORITY(6800)

    of event:alertKey

        validAlertKey# = False
        Case keyCode()
    #FOR(%listBoxAlerts)
        of %listBoxAlert
            validAlertKey# = True
    #ENDFOR
        End

        if validAlertKey# = True

            #IF(%treeMode)
            currentColumn# = 1
            #ELSE
            currentColumn# = %listControl{prop:Column}
            #ENDIF    

            ?editEntry{prop:Text} = %listControl{proplist:picture, currentColumn#}
            ?editEntry{prop:Use} = %treeQueue.%eipVariable
            %listControl{prop:Edit, currentColumn#} = ?editEntry
            select(?editEntry, 1, len(clip(%treeQueue.%eipVariable)))
        End

#ENDAT
	